/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// BlockType the model 'BlockType'
type BlockType string

// List of BlockType
const (
	BlockTypeText BlockType = "text"
	BlockTypeMedia BlockType = "media"
	BlockTypeQuestion BlockType = "question"
	BlockTypePause BlockType = "pause"
	BlockTypeReplyButtons BlockType = "reply_buttons"
	BlockTypeLinkButton BlockType = "link_button"
	BlockTypeCallButton BlockType = "call_button"
	BlockTypeActionButtons BlockType = "action_buttons"
	BlockTypeReplyList BlockType = "reply_list"
	BlockTypeDynamicList BlockType = "dynamic_list"
	BlockTypeRequestLocation BlockType = "request_location"
	BlockTypeMediaCards BlockType = "media_cards"
)

// All allowed values of BlockType enum
var AllowedBlockTypeEnumValues = []BlockType{
	"text",
	"media",
	"question",
	"pause",
	"reply_buttons",
	"link_button",
	"call_button",
	"action_buttons",
	"reply_list",
	"dynamic_list",
	"request_location",
	"media_cards",
}

func (v *BlockType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := BlockType(value)
	for _, existing := range AllowedBlockTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid BlockType", value)
}

// NewBlockTypeFromValue returns a pointer to a valid BlockType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewBlockTypeFromValue(v string) (*BlockType, error) {
	ev := BlockType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for BlockType: valid values are %v", v, AllowedBlockTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v BlockType) IsValid() bool {
	for _, existing := range AllowedBlockTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to BlockType value
func (v BlockType) Ptr() *BlockType {
	return &v
}

type NullableBlockType struct {
	value *BlockType
	isSet bool
}

func (v NullableBlockType) Get() *BlockType {
	return v.value
}

func (v *NullableBlockType) Set(val *BlockType) {
	v.value = val
	v.isSet = true
}

func (v NullableBlockType) IsSet() bool {
	return v.isSet
}

func (v *NullableBlockType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBlockType(val *BlockType) *NullableBlockType {
	return &NullableBlockType{value: val, isSet: true}
}

func (v NullableBlockType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBlockType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

